assange/database/models.py
import datetime

import sqlalchemy

from . import Base
from .utils import UUID, get_uuid

__all__ = ["Signature"]


class Signature(Base):
	__tablename__ = "signatures"

	id = sqlalchemy.Column(
		UUID,
		primary_key=True,
		default=get_uuid
	)

	name = sqlalchemy.Column(
		sqlalchemy.String(64),
		nullable=False
	)
	surname = sqlalchemy.Column(
		sqlalchemy.String(64),
		nullable=False
	)
	
	street = sqlalchemy.Column(
		sqlalchemy.String(128),
		nullable=False
	)
	city = sqlalchemy.Column(
		sqlalchemy.String(64),
		nullable=False
	)
	
	email = sqlalchemy.Column(
		sqlalchemy.String(128),
		nullable=True
	)
	comment = sqlalchemy.Column(
		sqlalchemy.String(65536),
		nullable=True
	)

assange/__init__.py
import json
import logging
import os
import typing

import flask
import flask_limiter
import flask_wtf.csrf
import sqlalchemy
import sqlalchemy.orm


logging.basicConfig(
	format="[%(asctime)s] %(levelname)s in %(module)s: %(message)s",
	level=getattr(
		logging,
		os.environ.get(
			"LOGGING_LEVEL",
			"DEBUG"
		)
	)
)


def create_app() -> flask.Flask:
	"""Creates a :class:`Flask <flask.Flask>` app with basic settings already
	applied.

	Loads the config from the file located where the ``CONFIG_LOCATION``
	environment variable describes, or ``$current_working_directory/config.json``
	if it's not set.

	Registers all blueprints in :mod:`.views`.
	"""

	app = flask.Flask(__name__)

	with app.app_context():
		app.logger.info("Setting up app")

		app.logger.debug("Loading environment file")

		for variable in (
			"SECRET_KEY",

			"SIGNATURE_VIEW_USERNAME",
			"SIGNATURE_VIEW_PASSWORD",

			"FRIENDLY_CAPTCHA_SECRET",
			"FRIENDLY_CAPTCHA_SITE_KEY",
			"FRIENDLY_CAPTCHA_ENDPOINT_PUZZLE",
			"FRIENDLY_CAPTCHA_ENDPOINT_VERIFICATION"
		):
			flask.current_app.config[variable] = os.environ[variable]

		app.logger.debug("Creating engine")

		database_url = os.environ["DATABASE_URL"]

		if database_url.startswith("postgres://"):
			database_url = database_url.replace("postgres://", "postgresql://")

		sa_engine = sqlalchemy.create_engine(database_url)

		app.sa_session_class = sqlalchemy.orm.scoped_session(
			sqlalchemy.orm.sessionmaker(
				bind=sa_engine
			)
		)

		app.logger.debug("Setting up extensions")

		app.limiter = flask_limiter.Limiter(
			app,
			key_func=lambda: (
				flask.request.headers["X-Forwarded-For"]
				if "X-Forwarded-For" in flask.request.headers
				else flask.request.remote_addr
			),
			default_limits=["300 per day", "100 per hour"]
		)
		flask_wtf.csrf.CSRFProtect(app)

		@app.before_request
		def before_request() -> None:
			"""TODO: doc"""

			flask.g.sa_session = flask.current_app.sa_session_class()

		@app.teardown_request
		def teardown_request(
			exception: typing.Union[None, Exception]
		) -> None:
			"""Attempts to commit :attr:`flask.g.sa_session` and rolls it back if
			any exception is raised during the process. The exception is then
			logged.

			:param exception: The exception that occurred in the prior request,
				if there was any.
			"""

			if "sa_session" in flask.g:
				# "Clean" the session
				try:
					flask.g.sa_session.commit()
				except Exception as commit_exception:
					flask.g.sa_session.rollback()

					flask.current_app.logger.error(
						"Exception %s raised during the request teardown session commit: %s",
						commit_exception.__class__.__name__,
						(
							commit_exception
							if hasattr(commit_exception, "__str__")
							else "no details"
						)
					)

				flask.current_app.sa_session_class.remove()

		from .views import petition_blueprint

		for blueprint in (petition_blueprint,):
			app.logger.debug(
				"Registering blueprint: %s",
				blueprint
			)

			app.register_blueprint(blueprint)

		@app.cli.command("reflect")
		def reflect() -> None:
			"""Reflects database models."""

			from .database import Base

			with app.sa_session_class() as sa_session:
				Base.metadata.create_all(bind=sa_engine)

		return app

assange/database/__init__.py
import sqlalchemy.orm

Base = sqlalchemy.orm.declarative_base()

from .utils import UUID, get_uuid
from .models import Signature

__all__ = [
	"Signature",
	"UUID",
	"get_uuid"
]

assange/utils/__init__.py
import flask
import functools


def login_required(function):
	@functools.wraps(function)
	def wrapped_view(**kwargs):
		auth = flask.request.authorization

		if (
			auth is None
			or auth.username != flask.current_app.config["SIGNATURE_VIEW_USERNAME"]
			or auth.password != flask.current_app.config["SIGNATURE_VIEW_PASSWORD"]
		):
			return (
				"Unauthorized",
				401,
				{
					"WWW-Authenticate": "Basic realm=\"Login Required\""
				}
			)

		return function(**kwargs)

	return wrapped_view

assange/views/__init__.py
from .petition import petition_blueprint


__all__ = ["petition_blueprint"]

assange/views/petition.py
import flask
import flask_wtf
import requests
import sqlalchemy
import wtforms

import werkzeug.exceptions

from .. import database, utils


petition_blueprint = flask.Blueprint(
	"petition",
	__name__
)


class SignatureForm(flask_wtf.FlaskForm):
	captcha_solution = wtforms.HiddenField(
		name="frc-captcha-solution"
	)
	
	name = wtforms.StringField(
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.Length(max=64)
		]
	)
	surname = wtforms.StringField(
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.Length(max=64)
		]
	)
	
	street = wtforms.StringField(
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.Length(max=128)
		]
	)
	city = wtforms.StringField(
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.Length(max=64)
		]
	)
	
	email = wtforms.EmailField(
		validators=[wtforms.validators.Length(max=128)]
	)
	comment = wtforms.TextAreaField(
		validators=[wtforms.validators.Length(max=65536)]
	)


@petition_blueprint.route("/", methods=["GET", "POST"])
@flask.current_app.limiter.limit(
	"2/day",
	exempt_when=lambda: flask.request.method != "POST"
)
def view():
	form = SignatureForm()

	added = False

	if form.validate_on_submit():
		captcha_verification_response = requests.post(
			flask.current_app.config["FRIENDLY_CAPTCHA_ENDPOINT_VERIFICATION"],
			json={
				"solution": form.captcha_solution.data,
				"secret": flask.current_app.config["FRIENDLY_CAPTCHA_SECRET"],
				"sitekey": flask.current_app.config["FRIENDLY_CAPTCHA_SITE_KEY"]
			}
		)

		if not captcha_verification_response.ok:
			flask.current_app.logger.error(
				"Friendly captcha returned status code %s, skipping verification",
				captcha_verification_response.status_code
			)
		elif not captcha_verification_response.json()["success"]:
			raise werkzeug.exceptions.Forbidden

		signature = database.Signature(
			name=form.name.data,
			surname=form.surname.data,
			street=form.street.data,
			city=form.city.data,
			email=form.email.data,
			comment=form.comment.data
		)

		flask.g.sa_session.add(signature)
		flask.g.sa_session.commit()

		added = True

	signature_count = flask.g.sa_session.execute(
		sqlalchemy.select(sqlalchemy.func.count(database.Signature.id))
	).scalars().one()

	return flask.render_template(
		"petition.html",
		form=form,
		added=added,
		signature_count=signature_count
	)


@petition_blueprint.route("/signatures", methods=["GET"])
@utils.login_required
def view_signatures():
	return flask.render_template(
		"signatures.html",
		signatures=flask.g.sa_session.execute(
			sqlalchemy.select(database.Signature)
		).scalars().all()
	)


@petition_blueprint.route("/gdpr", methods=["GET"])
def view_gdpr():
	return flask.render_template("gdpr.html")

assange/templates/gdpr.html
<!DOCTYPE html>
<html lang="cs">
	<head>
		<meta charset="utf-8">
		<title>Osvoboďmě Juliana Assange! - ochrana osobních údajů</title>
		
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		
		<link rel="stylesheet" href="{{ url_for('static', filename='fonts/inter/style.css') }}">
		<link rel="stylesheet" href="{{ url_for('static', filename='css/base.css') }}">
	</head>
	<body>
		<header>
			<h1>Ochrana osobních údajů</h1>
		</header>
		
		<main>
			<hr>
			
			<p>
				Osobní údaje v rozsahu, v jakém je vepisujete do online petice sbíráme pouze za účelem jejich předání adresátům petice, nevyužíváme je pro žádné jiné účely a nesmí tak ze zákona činit ani adresáti petice. Pro petici jsme zhotovili vlastní speciální stránku, takže vepisované osobní údaje se nedostanou k žádným třetím stranám. Pro předání petice pouze pořídíme výtisk online podpisových archů, které uchováme po dobu pro vyřízení a archivaci petice u jejích adresátů, abychom měli případně k prokázání penzum podpisů, pak je skartujeme, stejně jako smažeme původní databází online nasbíraných podpisů.
			</p>
			
			<p>
				Podle petičního zákona se počítá s vyřízením pouze „papírových“ petic, seznam lidí z online petice dodáme pro zvýšení váhy věci u státních orgánů-adresátů. Pokud máte možnost, podepište papírovou podobu petice, lze ji vytisknout <a
					href="{{ url_for('static', filename='petice.zip') }}"
				>zde na webu</a>, podepsat (a ještě lépe sehnat i další podpisy) a zaslat na adresu Dalibor Záhora,  Čimická 745/3, Praha 8, 182 00. Dvojí podepsání – jedno online a jedno fyzické, tedy nevadí.
			</p>
			
			<p>
				V případě dotazů a žádostí (například dotazu na rozsah a podobu svých osobních údajů,  odvolání souhlasu s podpisem petice, žádost o opravu či aktualizaci osobních údajů - tedy využití vašich zákonných práv) či námitek ohledně zpracování osobních údajů se obraťte na zástupce petentů Helenu Svatošovou: <a href="mailto:svatosova@iure.org">svatosova@iure.org</a> a máte právo obrátit se i na Úřad na ochranu osobních údajů (<a href="https://www.uoou.cz" target="_blank" rel="nofollow">www.uoou.cz</a>), pokud by podle Vás nebylo zpracování osobních údajů v pořádku. Dáváme ale na minimalizaci osobních údajů, jejich bezpečnost a správné zacházení velký pozor.
			</p>
			
			<p>
				Děkujeme, že jste svým hlasem pomohli neprávem stíhanému člověku a pomohli tlaku na aktéry české zahraniční politiky v této věci, vážíme si toho.
			</p>
			
			<p>
				Helena Svatošová, Linda Sokačová, Dalibor Záhora, iniciátoři petice a správci osobních údajů
			</p>
		</main>
		
		<footer>
			<hr>
			
			<p class="made-by">
				Vytvořil <a
					href="https://blog.imaniti.org"
					rel="nofollow"
					target="_blank"
				>Tomáš Valenta</a>. Sdílejte a nechte ostatní sdílet za stejných podmínek.
			</p>
			
			<div class="footer-images">
				<a
					href="https://en.wikipedia.org/wiki/Missionary_Church_of_Kopimism"
					rel="nofollow"
					target="_blank"
				><img
					src="{{ url_for('static', filename='images/kopimi.png') }}"
					height="40"
					alt="Kopimi"
				></a>
			</div>
		</footer>
	</body>
</html>

assange/templates/petition.html
<!DOCTYPE html>
<html lang="cs">
	<head>
		<meta charset="utf-8">
		<title>Osvoboďme Juliana Assange!</title>
		
		<link
			rel="icon"
			href="{{ url_for('static', filename='images/assange-square.png') }}"
			type="image/png"
		>
		
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		
		<meta name="author" content="Helena Svatošová, Linda Sokačová, Dalibor Záhora">
		<meta
			name="description"
			content="Julian Assange je vydavatel trestně stíhaný vládou, jejíž válečné zločiny odhalil. Je čas ho osvobodit."
		>
		
		<meta
			property="og:title"
			content="Osvoboďme Juliana Assange!"
		>
		<meta
			property="og:image"
			content="{{ url_for('static', filename='images/assange-square.png') }}"
		>
		<meta
			property="og:description"
			content="Julian Assange je vydavatel trestně stíhaný vládou, jejíž válečné zločiny odhalil. Je čas ho osvobodit."
		>
		
		<link rel="stylesheet" href="{{ url_for('static', filename='fonts/inter/style.css') }}">
		<link rel="stylesheet" href="{{ url_for('static', filename='css/base.css') }}">
		
		<!-- Bots forced us to do this. Sorry. -->
		<script
			type="module"
			src="{{ url_for("static", filename="js/friendlycaptcha-widget.module.min.js") }}"
			async
			defer
		></script>
		<script
			nomodule
			src="{{ url_for("static", filename="js/friendlycaptcha-widget.min.js") }}"
			async
			defer
		></script>
	</head>
	<body>
		<header>
			<img
				id="portrait"
				src="{{ url_for('static', filename='images/assange.png') }}"
				alt="Portrét"
			>
			
			<h1 id="main-header">
				<span style="color:#fff">Osvoboďme</span><br>
				<span style="color:#ed0f4e">Juliana Assange.</span>
			</h1>
		</header>
		
		<main>
			<hr>
			
			<p id="counter">
				Na online verzi petice bylo zatím nasbíráno <b>{{ signature_count }}</b> podpisů.<br>
				{% if added %}
					<b>Za tvůj srdečně děkujeme!</b> A budeme ještě radši, pokud o nás řekneš někomu dalšímu.
				{% else %}
					<b>Staň se autorem jednoho z nich!</b>
				{% endif %}
			</p>
			
			<hr>
			
			<p>
				Adresáti:
			</p>
			
			<ul>
				<li>Prezident České republiky,</li>
				<li>Vláda České republiky, předseda vlády,</li>
				<li>Poslanecká sněmovna Parlamentu České republiky, Zahraniční výbor,</li>
				<li>Senát Parlamentu České republiky, Výbor pro zahraniční věci, obranu a bezpečnost</li>
			</ul>
			
			<p>
				Vážení adresáti,
			</p>
			
			<p>
				žádáme touto peticí adresovanou záměrně více státním orgánům, abyste v rámci své působnosti diplomatickou i meziparlamentní cestou bezprostředně i dlouhodobě vyzývali
			</p>
			
			<ul>
				<li>
					vládu Spojených států amerických k stažení právního podání žádajícího vydání novináře Juliana Assange z Velké Británie do Spojených států amerických (USA);
				</li>
				<li>
					vládu Spojeného království Velké Británie a Severního Irska k nevydávání Juliana Assange a jeho propuštění z vazby.
				</li>
			</ul>
			
			<p>
				Soudní proces o vydání Juliana Assange do USA trpí závažnými nezákonnostmi (zajištění procesních práv Juliana Assange, absence nepodjatosti soudce) a samotná obžaloba Juliana Assange v USA čelí pochybám o její opodstatněnosti, pokud kriminalizuje práci novináře, který zveřejnil kriminalitu nejzásadnější – válečné zločiny. V průběhu procesu navíc vyvstaly zásadní pochyby o výpovědi klíčového svědka, který sám věrohodně vypověděl o nátlaku, pod kterým ji učinil.
			</p>
			
			<p>
				Za zásadní považujeme rovněž režimy ve věznicích v USA, které jsou v rozporu s právy na život, zdraví a důstojnost garantovanými evropským standardem (mj. Evropskou úmluvou o lidských právech a Chartou základních práv EU). Verbální vyjádření vlády USA o vynětí Juliana Assange z nejdrastičtějších vězeňských režimů v USA jsou nedostatečné, zvlášť ve světle nedávných veřejných odhalení plánů vlády USA na zcela nelegální zacházení s Julianem Assangem – únos či spáchání atentátu.
			</p>
			
			<p>
				Věříme, že vezmete dlouhodobou strategii české zahraniční politiky v prosazování lidských práv důsledně právě v případě kauzy Juliana Assange, jehož život je dle zjištění v řízení o extradici aktuálně ohrožen.
			</p>
			
			<p>
				Dne 10. 12. 2021 na Den lidských práv<br>
				v den rozhodnutí britského odvolacího soudu umožňujícího extradici Juliana Assange do USA
			</p>
			
			<h2 id="signature-call-to-action">Přidej svůj podpis.</h2>
			
			<form method="post">
				{{ form.csrf_token }}
				
				{{ form.name(placeholder="Jméno", autocomplete="off", value="") }}
				{{ form.surname(placeholder="Příjmení", autocomplete="off", value="") }}
				
				{{ form.street(placeholder="Ulice, č. p.", autocomplete="off", value="") }}
				{{ form.city(placeholder="Město", autocomplete="off", value="") }}
				
				{{ form.email(placeholder="E-mail (nepovinný)", autocomplete="off", value="") }}
				{{ form.comment(placeholder="Komentář (nepovinný)", autocomplete="off", value="") }}
				
				<div
					class="frc-captcha"
					data-puzzle-endpoint="{{ config["FRIENDLY_CAPTCHA_ENDPOINT_PUZZLE"] }}"
					data-sitekey="{{ config["FRIENDLY_CAPTCHA_SITE_KEY"] }}"
					data-lang="cs"
				></div>
				
				<input type="submit" value="Odeslat">
				
				<br>
				
				<small>
					<a
						href="{{ url_for('petition.view_gdpr') }}"
						rel="nofollow"
						target="_blank"
					>Ochrana osobních údajů</a>
					<br>
					Petiční výbor:
					
					<ul>
						<li>Helena Svatošová, Přístavní 35, Praha 7</li>
						<li>Linda Sokačová, Tusarova 10, Praha 7</li>
						<li>Dalibor Záhora, Čimická 745/3, Praha 8</li>
					</ul>
				</small>
		</main>
		
		<footer>
			<hr>
			
			<p class="made-by">
				Vytvořil <a
					href="https://blog.imaniti.org"
					rel="nofollow"
					target="_blank"
				>Tomáš Valenta</a>. Sdílejte a nechte ostatní sdílet za stejných podmínek.
			</p>
			
			<p>
				Assangova fotka - Kirsty Wigglesworth @ Associated Press. 
			</p>
			
			<div class="footer-images">
				<a
					href="https://en.wikipedia.org/wiki/Missionary_Church_of_Kopimism"
					rel="nofollow"
					target="_blank"
				><img
					src="{{ url_for('static', filename='images/kopimi.png') }}"
					height="40"
					alt="Kopimi"
				></a>
			</div>
		</footer>
	</body>
</html>

assange/templates/signatures.html
<!DOCTYPE html>
<html lang="cs">
	<head>
		<meta charset="utf-8">
		<title>Podpisy</title>
		<style type="text/css">
			html, body {
				font-family: sans-serif
			}
			
			/* Thanks to https://www.quackit.com/html/html_table_generator.cfm ! */
			table {
				width: 100%;
				background-color: #ffffff;
				border-collapse: collapse;
				border-width: 2px;
				border-color: #ed0f4e;
				border-style: solid;
				color: #000000;
			}

			table th {
				color: #fff;
			}

			table td, table th {
				border-width: 2px;
				border-color: #ed0f4e;
				border-style: solid;
				padding: 3px;
			}

			table thead {
				background-color: #ed0f4e;
			}
		</style>
	</head>
	<body>
		<table>
			<thead>
				<tr>
					<th>Jméno</th>
					<th>Příjmení</th>
					<th>Ulice, č. p.</th>
					<th>Město</th>
					<th>Email</th>
					<th>Komentář</th>
				</tr>
			</thead>
			
			<tbody>
				{% for signature in signatures %}
					<tr>
						<td>{% if signature.name != none %}{{ signature.name }}{% endif %}</td>
						<td>{% if signature.surname != none %}{{ signature.surname }}{% endif %}</td>
						<td>{% if signature.street != none %}{{ signature.street }}{% endif %}</td>
						<td>{% if signature.city != none %}{{ signature.city }}{% endif %}</td>
						<td>{% if signature.email != none %}{{ signature.email }}{% endif %}</td>
						<td>{% if signature.comment != none %}{{ signature.comment }}{% endif %}</td>
					</tr>
				{% endfor %}
			</tbody>
		</table>
	</body>
</html>